//Datei: i2c.h 
//
// hk@holger-klabunde.de 
// www.holger-klabunde.de 
//23.03.2003
//Compiler CC5x

#ifndef I2C_H
#define I2C_H

#define ACK	0  //Acknowledge vom Master nach Read
#define NACK	1  //kein Acknowledge vom Master nach Read

//I2C-Bus Adressen der angeschlossenen Bausteine
//EEPROM gendert auf 24C32. d.h. 16Bit Adressen in I2C-Protokoll
#define EEPROM	  	0xA0      //Schreiben
#define EEPROMREAD   EEPROM|0x01  //Lesen

#define LBN223		0x74        //Schreiben
#define LBN223READ	LBN223|0x01 //Lesen     

//Erster SAA1064
#define SAA1064A	0x70 //SAA1064 mit Pin Adr auf GND
#define SAA1064A_READ	SAA1064A|0x01

//Zweiter SAA1064
#define SAA1064B	0x72 //SAA1064 mit Pin Adr auf 1.88V
#define SAA1064B_READ	SAA1064B|0x01

//Dritter SAA1064
#define SAA1064C	0x74 //SAA1064 mit Pin Adr auf 3.13V
#define SAA1064C_READ	SAA1064B|0x01

//Vierter SAA1064
#define SAA1064D	0x76 //SAA1064 mit Pin Adr auf 5V
#define SAA1064D_READ	SAA1064B|0x01

#define LM75A		0x90 //erster LM75
#define LM75A_READ	LM75A|0x01 //erster LM75

#define SCL	PORTA.3
#define SDA	PORTA.4
#define SDA_T   4        //Pinnummer fr TRISA.x !

//Der Clockzyklus sollte max. 100kHz/10us werden !
//Takt des PIC 4MHz -> ein Taktzyklus = 1us
#define SCL_ON() {  SCL=1; Delay10us(); }
#define SCL_OFF() { SCL=0; Delay10us(); }
#define SDA_ON() {  TRISA.SDA_T=1; Delay10us(); }
#define SDA_OFF() { TRISA.SDA_T=0; SDA=0; Delay10us(); }

#endif
