// Datei: saa1064.C
//
// I2C-Bus LED-Multiplexer SAA1064
// 7-Segment Anzeige mit 4 Stellen ansteuern
//
// Holger Klabunde
// 14.01.2001
// Compiler CC5x
#include "prozess.h"      /* Der verwendete Prozessor */
#include "saa1064.h"
#include "protos.h"

//Der SAA1064 kann alle LED's einzeln ansteuern
//So kann man z.B. auch nur drei 7-Segmentanzeigen benutzen
//Die brigen 8 LED's knnen dann einzeln angesteuert werden.
//Z.B. Vorzeichen, Einstellungen, Balkenanzeige usw.
//Es sind also beliebige Displays mit bis zu 32 LED' mglich

//bersetzungstabelle fr die bentigten LED-Segmente zu der darzustellenden Zahl
//Die Tabelle gilt nur fr meine Hardwareverdrahtung der Anzeige !

//Tabelle fr die Stellen 1 und 2
const unsigned char digit12[] = { 0xBB,0xA0,0x9E,0xB6,0xA5,0x37,0x3F,0xA2,0xBF,0xB7 };
//Tabelle fr die Stellen 3 und 4
const unsigned char digit34[] = { 0xEB,0x09,0x67,0x2F,0x8D,0xAE,0xEE,0x0B,0xEF,0xAF };

unsigned char saa_adr; //Globale bergabe der Adresse des anzusprechenden SAA1064

//###############################################################
//Zahl umwandeln in den entsprechenden Code fr den SAA1064
//###############################################################
unsigned char ConvertDigit( unsigned char pos, unsigned char num)
{
 unsigned char tmp;

 if(num>9) return 0; //Arraygrenzen unbedingt einhalten

 switch(pos) //Code ist abhngig von der Position
  {
   case 1: case 2: tmp=digit12[num]; break; //Stelle 1+2
   case 3: case 4: tmp=digit34[num]; break; //Stelle 3+4
   default: tmp=0; break; //ungltige Position
  }

 return tmp;
}

//###################################################
//Schreibt ein Byte in den SAA1064
//###################################################
void SAA1064Write(unsigned char adr, unsigned char dat)
{
 I2C_START(); //Startbedingung senden,enthlt I2C_STOP()!!

 I2C_Write(saa_adr); //I2C-Adresse und SchreibBit senden
// if(I2CERR>0) { return; }

 I2C_Write(adr); //Gewnschte Adresse bertragen
// if(I2CERR>0) { return; }

 I2C_Write(dat); //Byte schreiben
// if(I2CERR>0) { return; }

 I2C_STOP();

}
