// Datei: lbntest.c
// Steuert I2C-Textdisplay LBN223
//
// hk@holger-klabunde.de 
// www.holger-klabunde.de 
// 23.03.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "saatest.h"
#include "protos.h"

#include "delay.c"
#include "i2c.c"
#include "saa1064.c"
#include "binbcd16.c"
#include "lcd.c"

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char by,dp;
 unsigned long count;

 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Port einmal schreiben

 TRISA=0b10000;     //0=Ausgang, 1=Eingang
 PORTA=0b01000;  //Port einmal schreiben

 LCDInit();
 LCDCls();
 
 saa_adr=SAA1064A;      //erster SAA1064
 SAA1064Write(0,0x27); //Arbeitsmode und Helligkeit der LED's einstellen
 saa_adr=SAA1064D;      //vierter SAA1064
 SAA1064Write(0,0x27); //Arbeitsmode und Helligkeit der LED's einstellen

 count=0;
 dp=0; //Zhlt die Position des wandernden Dezimalpunktes

 LCDWrite("SAA1064 Test");

 while(1)
  {
   B1=(unsigned char)(count>>8);     //Highbyte
   B0=(unsigned char)(count&0x00FF); //Lowbyte
   BinToBCD16(); //Wandeln in BCD-Code, Ergebnis in R0..2, R0=MSB

   by=R1>>4; //Stelle 1
   by=ConvertDigit(1,by); //wandeln in den Code fr SAA1064
   if(dp==0) by|=DPOINT12; //Dezimalpunkt setzen
   saa_adr=SAA1064A;      //erster SAA1064
   SAA1064Write(1,by);    //Stelle schreiben
   saa_adr=SAA1064D;      //zweiter SAA1064
   SAA1064Write(1,by);    //Stelle schreiben

   by=R1&0x0F; //Stelle 2
   by=ConvertDigit(2,by); //wandeln in den Code fr SAA1064
   if(dp==1) by|=DPOINT12; //Dezimalpunkt setzen
   saa_adr=SAA1064A;      //erster SAA1064
   SAA1064Write(2,by);    //Stelle schreiben
   saa_adr=SAA1064D;      //zweiter SAA1064
   SAA1064Write(2,by);    //Stelle schreiben

   by=R2>>4; //Stelle 3
   by=ConvertDigit(3,by); //wandeln in den Code fr SAA1064
   if(dp==2) by|=DPOINT34; //Dezimalpunkt setzen
   saa_adr=SAA1064A;      //erster SAA1064
   SAA1064Write(3,by);    //Stelle schreiben
   saa_adr=SAA1064D;      //zweiter SAA1064
   SAA1064Write(3,by);    //Stelle schreiben
   
   by=R2&0x0F; //Stelle 4
   by=ConvertDigit(4,by); //wandeln in den Code fr SAA1064
   if(dp==3) by|=DPOINT34; //Dezimalpunkt setzen
   saa_adr=SAA1064A;      //erster SAA1064
   SAA1064Write(4,by);    //Stelle schreiben
   saa_adr=SAA1064D;      //zweiter SAA1064
   SAA1064Write(4,by);    //Stelle schreiben

   count++;
   dp++;
   if(dp==4) dp=0;
   if(count>9999) count=0; //Anzeige ist nur vierstellig

   Delay1ms(100);
   
  }//while 1
     
}
